## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## ForensicsUtils
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import random
import string
import cPickle

gc = CyGlobalContext()

def getInfoOnObject(pObj):
    sObj = str(pObj.__class__)
    sFields = str(pObj.__dict__)
    pPlayer = gc.getPlayer(0)
    iX = pPlayer.getStartingPlot().getX()
    iY = pPlayer.getStartingPlot().getY()
    #sMethods = str(pObj.__methods__)
    #sMembers = str(pObj.__members__)
    sDir = str(dir(pObj))
    count = 0
    for sField in dir(pObj):
        sField = str(sField)
        if(sField[0] != '_'):
            count = count + 1
            if(count > 2):
                message = sField
                CyInterface().addMessage(0,True,len(message),message,'AS2D_BOMBARDED',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(6),iX,iY,True,True)
    
                sAttrDir = str(dir(getattr(pObj, sField)))
                break
                
    methodList = [method for method in dir(pObj) if callable(getattr(pObj, method))]
    #methodList = [method for method in methodList if method[0] != '_']
    #methodList = [method for method in methodList if method[0] == 'g']
    #methodList = [method for method in methodList if method.count("getM") > 0]
    fieldList = [field for field in dir(pObj) if not callable(getattr(pObj, field))]
    processFunc = 1 and (lambda s: " ".join(s.split())) or (lambda s: s)
    message =  "\n".join(["%s %s" %(method.ljust(30), processFunc(str(getattr(pObj, method).__doc__))) for method in methodList])
    CyInterface().addMessage(0,True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),iX,iY,True,True)
    #message = message + "\n".join(["%s %s" %(field.ljust(30), str(type(getattr(pObj, field)))) for field in fieldList])
    message = "\n".join(["%s %s" %(field.ljust(30), str(type(getattr(pObj, field)))) for field in fieldList])
    CyInterface().addMessage(0,True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),iX,iY,True,True)
    #message = "Object:" + sObj + "\nFields:" + sFields + "\nMethods:" + sMethods +"\nMembers" + sMembers
    #message = "Object:" + sObj + "\nFields:" + sDir + "\nTest: " + sAttrDir
    #message = "Object:" + sObj + "\nFields:" + sDir
    #message = "Object:" + sObj + "\n\n" + message
    message = "Object:" + sObj + "\n\n"
    CyInterface().addMessage(0,True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),iX,iY,True,True)
