## Colonize the Moon Mod Project
## Changes copyright Shin 2005
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
##
## TechUtils
#
# --Shin
# (aka. Belizan)

from CvPythonExtensions import *
from types import *
import random
import string
import cPickle
import Config

gc = CyGlobalContext()
    
def getTagEncodedType(iTech):
    eTech = gc.getTechInfo(iTech).getType()
    iDX = string.rindex(eTech, '_') + 1
    eTech = eTech[iDX:]
    if (eTech in Config.TagEncodings):
        return eTech
    else:
        return "NONE"
        
# Currently assumes iTech is an untagged tech
def isSuchTaggedTech(iTech, lTags):
    eTech = gc.getTechInfo(iTech).getType()
    for eTag in lTags:
        sType = eTech + eTag
        if(gc.getInfoTypeForString(sType) != -1):
            return True
    return False